(in-package :usocket)

(defun socket-connect/udp (host port &key (stream nil) (element-type 'character)
			   local-address local-port)
  (let ((socket))
    (if (and host port)
	(setf socket
	      (with-mapped-conditions (socket)
		(socket:make-socket :type :datagram
				    :address-family :internet
				    :connect :active
				    :remote-host (host-to-hostname host)
				    :remote-port port
				    :local-host (if local-address
						    (host-to-hostname local-address)
						    nil)
				    :local-port local-port
				    :format (to-format element-type))))
	(setf socket
	      (with-mapped-conditions (socket)
		(socket:make-socket :type :datagram
				    :address-family :internet
				    :local-host (if local-address
						    (host-to-hostname local-address)
						    nil)
				    :local-port local-port
				    :format (to-format element-type)))))
    (make-datagram-socket socket)))

(defmethod socket-send ((socket datagram-usocket) buffer length &key address port)
  (let ((s (socket socket)))
    (socket:send-to s buffer length :remote-host address :remote-port port)))

(defmethod socket-receive ((socket datagram-usocket) buffer length)
  (let ((s (socket socket)))
    (socket:receive-from s length :buffer buffer :extract t)))
