;;;; -*- Mode: lisp; Syntax: ansi-common-lisp; Base: 10; Package: usocket; -*-

#|
<DOCUMENTATION>
 <DESCRIPTION>
  UDP support patch for USOCKET project. This file should sync with usocket-svn at

    svn://common-lisp.net/project/usocket/svn/usocket/trunk

  Waiting for USOCKET author to merge us.
  </DESCRIPTION>
 <COPYRIGHT YEAR='2007-2008' AUTHOR='Chun Tian (binghe)' MARK='(C)'
            HREF='https://cl-net-snmp.svn.sourceforge.net/svnroot/cl-net-snmp/usocket-udp/trunk/udp-server.lisp'/>
 <CHRONOLOGY>
  <DELTA DATE='20080402'>move to standalone usocket-udp subproject</DELTA>
  <DELTA DATE='20080317'>create USOCKET UDP patch file "udp-server.lisp"</DELTA>
  </CHRONOLOGY>
 </DOCUMENTATION>
|#

(in-package :usocket)

(defclass datagram-server-usocket (usocket)
  ((process :initarg :process
	    :accessor process
	    :documentation "UDP server thread"))
  (:documentation "UDP server socket"))

(defun datagram-server-usocket-p (socket)
  (typep socket 'datagram-server-usocket))

(defun make-datagram-server-socket (socket process)
  (unless socket
    (error 'invalid-socket))
  (make-instance 'datagram-server-usocket
		 :socket socket
		 :process process))

(defun start-udp-server (host port &key (function #'identity))
  )

(defun stop-udp-server (usocket)
  )

(defun udp-server-loop ()
  )

:eof
