;;;; -*- Mode: Lisp; Package: ASDF; -*-

#|
<DOCUMENTATION>
 <DESCRIPTION>
  ASDF system definition for USOCKET-UDP

  </DESCRIPTION>
 <COPYRIGHT YEAR='2007-2008' AUTHOR='Chun Tian (binghe)' MARK='(C)'
            HREF='https://cl-net-snmp.svn.sourceforge.net/svnroot/cl-net-snmp/usocket-udp/trunk/usocket-udp.asd'/>
 <CHRONOLOGY>
  <DELTA DATE='20080402'>move to standalone usocket-udp subproject</DELTA>
  <DELTA DATE='20080316'>create documentation for "usocket-udp.asd"</DELTA>
  </CHRONOLOGY>
 </DOCUMENTATION>
|#

(in-package :asdf)

(defsystem usocket-udp
  :description "UDP support for the USOCKET project"
  :version "1.1"
  :author "Chun Tian (binghe) <binghe.lisp@gmail.com>"
  :depends-on (:usocket
               #+lispworks :lispworks-udp
	       :portable-threads)
  :serial t
  :components ((:file "usocket")
	       #+allegro   (:file "usocket-allegro")
               #+clozure   (:file "usocket-clozure")
               #+cmu       (:file "usocket-cmucl")
               #+sbcl      (:file "usocket-sbcl")
               #+lispworks (:file "usocket-lispworks")
               (:file "usocket-server")))

:eof
